Bug 213783 - alsa's arecord stops recording after 3hrs 23min.
alsa's arecord stops recording after 3hrs 23min.
Status: CLOSED WONTFIX
Product: Fedora
Classification: Fedora
Component: alsa-utils (Show other bugs)
6
i386 Linux
medium Severity medium
: ---
: ---
Assigned To: Martin Stransky
bzcl34nup
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2006-11-02 18:12 EST by Wolfgang Rupprecht
Modified: 2008-08-02 19:40 EDT (History)
1 user (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2008-05-06 12:40:58 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Wolfgang Rupprecht 2006-11-02 18:12:39 EST
Description of problem:

alsa's arecord stops recording after 3hrs 23min when recording in CD
format.  (44100 samples/sec, 2 channel, 16bits / sample)

Most notable this is approximately the time required to reach 2^31
bytes.  I suspect some variable that should have been a ssize_t is
erroniously an int and it is rolling over.

The exact roll-over for cd-audio would be at 3 hrs 22 min 53.94 sec,
which is pretty close to my observed blow-up.

Version-Release number of selected component (if applicable):

alsa-utils-1.0.12-3.fc6

How reproducible:

unknown

Steps to Reproduce:
1. add a shell script called pcmaudiod to xinetd's tcp daemon's
2. put this one line in the shell script: arecord -q -f cd - 
3. connect up a tcp listener and wait 3 hrs 23 min.
  
Actual results:
recording stops while listener was expecting it to continue.

Expected results:
recording should continue till listener closes his end of the tcp connection.

Additional info:
I'll try to reproduce.  Given how long this takes, it is going to be fun.

I don't know if this happens on a local file copy or if it is a result
of something in the tcp stream.
Comment 1 Wolfgang Rupprecht 2006-11-03 10:33:40 EST
I ran an extended test with arecord's output going to a local file.  At roughly 
the same point in time arecord closed the output file, renmaed it
filename-01.wav and opened a second file filename-02.wav.  The byte-count for
this transition to a second file was 2147483692 bytes (very roughly 2^31 bytes
minus a bit of padding).

-rw-r--r-- 1 root     wsrcc 2147483692 Nov  2 18:46 arecord-01.wav
-rw-r--r-- 1 root     wsrcc 2147483692 Nov  2 22:11 arecord-02.wav
-rw-r--r-- 1 root     wsrcc  278592044 Nov  2 22:38 arecord-03.wav

It now appears that the closing of the tcp stream is a botch caused 
by the program attempting to roll files in order to keep them under 2^31 bytes.

Personally, the mandatory rolling of the files already strikes me as a
misfeature.  If I wanted a contigious 4 gig file the program should let me have
it.  Closing a stdout stream after 2^31 bytes is just a bug on top of things.
Comment 2 Martin Stransky 2007-04-10 06:27:58 EDT
Could you please test this package? It contains a large file support. (rebuild
it as root with "rpmbuild --rebuild package.rpm" and install from
/usr/src/redhat/RPMS)

http://people.redhat.com/stransky/alsa/test/alsa-utils-1.0.14-0.3.rc2.fc7.src.rpm
Comment 3 Bug Zapper 2008-04-04 00:22:54 EDT
Fedora apologizes that these issues have not been resolved yet. We're
sorry it's taken so long for your bug to be properly triaged and acted
on. We appreciate the time you took to report this issue and want to
make sure no important bugs slip through the cracks.

If you're currently running a version of Fedora Core between 1 and 6,
please note that Fedora no longer maintains these releases. We strongly
encourage you to upgrade to a current Fedora release. In order to
refocus our efforts as a project we are flagging all of the open bugs
for releases which are no longer maintained and closing them.
http://fedoraproject.org/wiki/LifeCycle/EOL

If this bug is still open against Fedora Core 1 through 6, thirty days
from now, it will be closed 'WONTFIX'. If you can reporduce this bug in
the latest Fedora version, please change to the respective version. If
you are unable to do this, please add a comment to this bug requesting
the change.

Thanks for your help, and we apologize again that we haven't handled
these issues to this point.

The process we are following is outlined here:
http://fedoraproject.org/wiki/BugZappers/F9CleanUp

We will be following the process here:
http://fedoraproject.org/wiki/BugZappers/HouseKeeping to ensure this
doesn't happen again.

And if you'd like to join the bug triage team to help make things
better, check out http://fedoraproject.org/wiki/BugZappers
Comment 4 Bug Zapper 2008-05-06 12:40:56 EDT
This bug is open for a Fedora version that is no longer maintained and
will not be fixed by Fedora. Therefore we are closing this bug.

If you can reproduce this bug against a currently maintained version of
Fedora please feel free to reopen thus bug against that version.

Thank you for reporting this bug and we are sorry it could not be fixed.

Note You need to log in before you can comment on or make changes to this bug.